module JsonVoorhees
	class AppMakeUserGenerator < Rails::Generators::Base
	  source_root File.expand_path('../templates', __FILE__)
    class_option :fbonly, :type => :boolean, :default => false, :description => "Use facebook login?"

    def sprint
      route "mount Arcadex::Engine, at: \'/\'"
      if options.fbonly?
        fb_only
      else
        people
      end
    end

    private

      def fb_only
        run "git clone https://github.com/cleor41/fbuser.git"
        run "mv fbuser engines/fbuser"
        run "rm -rf engines/fbuser/.git"
        #Need to add the engine to the main_apps gemfile
        route "mount Fbuser::Engine, at: \'/\'"
        insert_fb_user_engine
        run "rails g fbuser:all"
      end

      def insert_fb_user_engine
        inject_into_file 'Gemfile', after: "source \'https://rubygems.org\'\n" do <<-'RUBY'

  gem 'fbuser', :path => "engines/fbuser"

        RUBY
        end
      end

      def people
        run "git clone https://github.com/cleor41/people.git"
        run "mv people engines/people"
        run "rm -rf engines/people/.git"
    		#Need to add the engine to the main_apps gemfile
        route "mount People::Engine, at: \'/\'"
        insert_people_engine
        run "rails g people:all"
      end

      def insert_people_engine
  			inject_into_file 'Gemfile', after: "source \'https://rubygems.org\'\n" do <<-'RUBY'

  gem 'people', :path => "engines/people"

  			RUBY
  			end
      end

	end
end
