module JsonVoorhees
	class MassiveScaffoldGenerator < Rails::Generators::Base
	  source_root File.expand_path('../templates', __FILE__)
	  argument :module_name, :type => :string
	  argument :resource_name, :type => :string
	  argument :api_version, :type => :string, :default => "1"
	  argument :attributes, type: :array, default: [], banner: "field:type field:type"

	  def sprint
	  	inside "engines/#{module_name.underscore}" do
  			# We should skip making the migration if this is not version 1
  			# Chaned scaffold to model here, dont need the other routes
	  		if api_version != "1"
	  			run "rails g model #{resource_name} #{attributes.join(" ")} --no-migration "
	  		else
	  			run "rails g model #{resource_name} #{attributes.join(" ")}"
	  		end
	  		run "rails g json_voorhees:engine_scaffold #{module_name} #{resource_name} #{api_version} #{attributes.join(" ")}"
	  		correct_routes
	  	end
	  	run "rails g json_voorhees:app_scaffold #{module_name} #{resource_name} #{api_version} #{attributes.join(" ")}"
  		#run "rails generate active_admin:resource #{module_name.underscore.downcase}::#{resource_name.singularize.underscore.downcase}"
  		make_custom_active_admin

	  end

	  private

	  	def correct_routes
	  		#Don't have to comment out the old routes, they aren't created anymore. Also stopped new and edit from being created
	  		#gsub_file 'config/routes.rb', "resources :#{resource_plural}", "#resources :#{resource_plural}"
	  		gsub_file 'config/routes.rb', "scope '1' do\n", "scope '1' do\n\t\t\tresources :#{resource_plural}, except: [:new, :edit], controller: \'api/v1/#{resource_plural}\'\n"
	  	end

	  	def make_custom_active_admin
	  		template "active_admin_register.rb.erb", "app/admin/#{module_name.underscore}_#{resource_singular}.rb"
	  	end

			def params_list
		  	params = []
		  	attributes.each do |pair|
		  		elem = pair.split(/:/)[0]
		  		field = ":#{elem}"
		  		params << field
		  	end
		  	return params.join(",")
		  end

		  def resource_singular
		  	resource_name.underscore.singularize
		  end

		  def resource_plural
		  	resource_name.underscore.pluralize
		  end

		  def resource_camel
		  	resource_name.camelize.singularize
		  end

		  def menu_name
		  	resource_name.camelize.pluralize
		  end

		  def module_camel
		  	module_name.camelize
		  end

		  def module_snake
		  	module_name.underscore.downcase
		  end

	end
end
